
/*created 2013 by Volker Mink (aquafish007) <http://www.aquaticsolution.de>*/

//#include <math.h>
//#include <LiquidCrystal_I2C.h>
#include <LiquidCrystal_I2C.h>
#include <Wire.h> 
#include <DS1307.h>
#include <EEPROMex.h>
#include <OneWire.h>
#include <DallasTemperature.h>
//#include <AFMotor.h>

#if defined(ARDUINO) && ARDUINO >= 100
#define printByte(args)  write(args);
#else
#define printByte(args)  print(args,BYTE);
#endif

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ H A R D W A R E +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
//Initialisierung
DS1307 rtc(16, 17);

uint8_t bell[8]  = {0x4,0xe,0xe,0xe,0x1f,0x0,0x4};
uint8_t note[8]  = {0x2,0x3,0x2,0xe,0x1e,0xc,0x0};
uint8_t clock[8] = {0x0,0xe,0x15,0x17,0x11,0xe,0x0};
uint8_t heart[8] = {0x0,0xa,0x1f,0x1f,0xe,0x4,0x0};
uint8_t duck[8]  = {0x0,0xc,0x1d,0xf,0xf,0x6,0x0};
uint8_t check[8] = {0x0,0x1,0x3,0x16,0x1c,0x8,0x0};
uint8_t cross[8] = {0x0,0x1b,0xe,0x4,0xe,0x1b,0x0};
uint8_t retarrow[8] = {	0x1,0x1,0x5,0x9,0x1f,0x8,0x4};

LiquidCrystal_I2C lcd(0x3F,20,4);  // set the LCD address to 0x3F for a 2 chars and 4 line display

//Pins
int R1Pin = 13;  //Pin für Relais 1

//Initialisierung Temp Sensor, PIN 2
#define ONE_WIRE_BUS 2

// Setup a oneWire instance to communicate with any OneWire devices 
// (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);

// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);

//Motoren
//AF_DCMotor motor1(1);
//AF_DCMotor motor2(2);
//AF_DCMotor motor3(3);
//AF_DCMotor motor4(4);

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ K O N S T A N T E N +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
const int DISPLAY_LETZTE_SEITE = 2;
const int DISPLAY_WARTEZEIT = 5;
const long HOUR = 60 * 60;
const long MINUTE = 60;
const int MAXPWMSTEPS = 4096;

//Hier werden die Tasten des Keyboards festgelegt und müssen je nach Keypad angepasst werden
#define RIGHTKEY 0
#define UPKEY 1
#define DOWNKEY 2
#define LEFTKEY 3
#define SELECTKEY 4

Time rtcClock;
long lTime;
long Sekunde;
long Minute;
long HourTime;


//Variablen Display
int intSekunden;
int intDisplayAktuelleSeite = 0;
int intDisplayLetzteSeite = 0;
int intDisplayWartezeit = 0;

//Menühelper
int SetDisplayHelper = 0;
int SetDisplayHelperDate = 0;

//Menü
int MenuTiefe = 0;
int MenuEbene0 = 0;
int MenuEbene1 = 0;
int MenuEbene2 = 0;
boolean FirstSelect = false;

//HD44780U (LCD-II)Oktal-Codes für Umlaute (-see page 17 on Datasheet for ROM Code: A00-):
//ö =  \357
//ä =  \341
//ü =  \365

//Hauptmenü
char sMenuHaupt[3][20] = {
  "Starten", "Grundeinstellung", "Nachf\365llanlage" };
const int MENUHAUPT = 2;

//Grundeinstellung-Menü
char sMenuGrundeinstellung[4][20] = {
  "Hauptmen\365", "Datum", "Uhrzeit", "Tag"};
const int MENUGRUNDEINSTELLUNG = 3;

//Nachf-Menü
char sMenuNachfeinstellung[4][20] = {  
  "Hauptmen\365", "Nachf\365llzeit 1", "Nachf\365llzeit 2", "Manuell" };
boolean Nachfmanuell_1;
const int MENUNACHFEINSTELLUNG = 3;

//--------------------------------D O S I E R P U M P E N - M O D U L E--------------------------------------
//Nachfzeit 1
const int MENUNACHFZEIT1 = 2;
char sMenuNachfzeit1[MENUNACHFZEIT1 + 1][20] = {
  "zur\365ck          ", "Nachf\365llzeit 1     ", "Nachf\365lldauer   " };
//const int M1_MENUDOSIERPORT_1 = 11;
Time Nachfzeit1;
Time Nachfdauer1;
long Nachfautomatzeit1;
long Nachfautomatdauer1;
long Endtime1;

//Nachfzeit 2
const int MENUNACHFZEIT2 = 2;
char sMenuNachfzeit2[MENUNACHFZEIT2 + 1][20] = {
  "zur\365ck          ", "Nachf\365llzeit 2     ", "Nachf\365lldauer   " };
//const int M1_MENUDOSIERPORT_1 = 11;
Time Nachfzeit2;
Time Nachfdauer2;
long Nachfautomatzeit2;
long Nachfautomatdauer2;
long Endtime2;


//-------------------------------------------------------------------------------------------------------

// Tasten
//int adc_key_val[5] ={50, 220, 430, 630, 990 };
int adc_key_val[5] ={ 
  50, 200, 400, 600, 800 };
int NUM_KEYS = 5;
int adc_key_in;
int key=-1;
int oldkey=-1;



void setup() 
{
  Serial.begin(9600);
  lcd.init();
  lcd.backlight();
  
  // Temperatur
  sensors.begin();

  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print("Init...");


  //Unsere Uhr
  rtc.halt(false);

  //Dosierautomat
  //Wenn im EEPROM noch nichts drinnen steht und damit keine komischen Zahlen beim Auslesen des EEPROMS kommen, kann man Default-Werte setzen, die beim allerersten Start gesetzt werden
  // Ein Beschreibungszyklus dauert 3.3 ms, ich gebe Ihm mal 5 ms.
  // Zur Information: Das Beschreiben des EEPROMS ist "nur" 100.000 mal möglich, danach ist es kaputt!
  if (EEPROM.readInt(0) != 0)
  {
    rtc.setDOW(SATURDAY);
    rtc.setTime(13, 30, 0);
    rtc.setDate(7, 9, 2013);

    //Nachfzeit 1
    Nachfzeit1.hour = EEPROM.writeInt(10,10); //EEPROM.writeInt(Adresse = 10,Wert = 10 Uhr);
    Nachfzeit1.min = EEPROM.writeInt(12,00);
    Nachfdauer1.hour = EEPROM.writeInt(14,00);
    Nachfdauer1.min = EEPROM.writeInt(16,10);
    Nachfmanuell_1 = EEPROM.writeByte(19,0); //false;
    //Endtime1 = 0;
    //Dosierzeit1 = 30; //Sekunden

    //Nachfzeit 2
    Nachfzeit2.hour = EEPROM.writeInt(20,10); //EEPROM.writeInt(Adresse = 10,Wert = 10 Uhr);
    Nachfzeit2.min = EEPROM.writeInt(22,00);
    Nachfdauer2.hour = EEPROM.writeInt(24,00);
    Nachfdauer2.min = EEPROM.writeInt(26,10);
    //Endtime1 = 0;
    //Dosierzeit1 = 30; //Sekunden


    Nachfzeit1.hour = EEPROM.readInt(10);
    Nachfzeit1.min = EEPROM.readInt(12);
    Nachfdauer1.hour = EEPROM.readInt(14);
    Nachfdauer1.min = EEPROM.readInt(16);
    Nachfmanuell_1 = EEPROM.readByte(19);

    Nachfzeit2.hour = EEPROM.readInt(20);
    Nachfzeit2.min = EEPROM.readInt(22);
    Nachfdauer2.hour = EEPROM.readInt(24);
    Nachfdauer2.min = EEPROM.readInt(26);
    
    EEPROM.writeInt(0,0);
  }

  else
  {     
    
    Nachfzeit1.hour = EEPROM.readInt(10);
    Nachfzeit1.min = EEPROM.readInt(12);
    Nachfdauer1.hour = EEPROM.readInt(14);
    Nachfdauer1.min = EEPROM.readInt(16);
    Nachfmanuell_1 = EEPROM.readByte(19);

    Nachfzeit2.hour = EEPROM.readInt(20);
    Nachfzeit2.min = EEPROM.readInt(22);
    Nachfdauer2.hour = EEPROM.readInt(24);
    Nachfdauer2.min = EEPROM.readInt(26);


  }

//PinMode
pinMode(R1Pin, OUTPUT);

}

void loop() 
{
  Time time = rtc.getTime();

  //Display
  if (intSekunden != time.sec && MenuTiefe == 0)
  {
    if (intDisplayWartezeit == DISPLAY_WARTEZEIT)
    {
      Display(intDisplayAktuelleSeite);
      intDisplayAktuelleSeite++;

      if (intDisplayAktuelleSeite == DISPLAY_LETZTE_SEITE)
        intDisplayAktuelleSeite = 0;

      intDisplayWartezeit = 0;  
    }
    intSekunden = time.sec ;
    intDisplayWartezeit++;
  }  


  key = 0;
  adc_key_in = analogRead(0);
  key = get_key(adc_key_in);
  if (key != oldkey)
  {
    delay(50);
    adc_key_in = analogRead(0);
    key = get_key(adc_key_in);
    if (key != oldkey)
    {
      oldkey = key;

      if (key >=0)
      {
        MenuWerteAuswahl();
        MenuWerteSetzen();       
      }
    }
    
  }  
  

  //Jetz geht's los
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++ A K T U E L L E  Z E I T ++++++++++++++++++++++++++++++++++++++++++++++++++
  lTime = (time.hour * HOUR) + (time.min * MINUTE) + time.sec;
  Sekunde = time.sec;
  Minute = (time.min * MINUTE);
  HourTime = Sekunde + Minute;

  //+++++++++++++++++++++++++++++++++++++ N A C H F Z E I T E N +++++++++++++++++++++++++++++++++++++++++++++++++++



  Nachfautomatzeit1 = (Nachfzeit1.hour * HOUR) + (Nachfzeit1.min * MINUTE) + Nachfzeit1.sec;
  Nachfautomatzeit2 = (Nachfzeit2.hour * HOUR) + (Nachfzeit2.min * MINUTE) + Nachfzeit2.sec;
  Nachfautomatdauer1 = (Nachfdauer1.hour * HOUR) + (Nachfdauer1.min * MINUTE) + Nachfdauer1.sec;
  Nachfautomatdauer2 = (Nachfdauer2.hour * HOUR) + (Nachfdauer2.min * MINUTE) + Nachfdauer2.sec;

  //1. Abfrage: Wann soll dosiert werden
  //2. Abfrage: manuelle Zeitschleifensteuerung zur Messung; hier default-Wert 60 Sekunden
  //3. Abfrage: manuelle Streuerung An/Aus
  //Nachfzeit 1
  if  (((lTime >= Nachfautomatzeit1) && (lTime <= Nachfautomatzeit1 + Nachfautomatdauer1)) || (Nachfmanuell_1 == true))
  {        
    digitalWrite(R1Pin, LOW);
  }
  else
  {
    digitalWrite(R1Pin, HIGH);
//    Endtime1 = 0;   
  }

  //Nachfzeit 2
  if  (((lTime >= Nachfautomatzeit2) && (lTime <= Nachfautomatzeit2 + Nachfautomatdauer2)) )//|| ((Endtime2 > 0) && (lTime <= Endtime2)))
  {        
     digitalWrite(R1Pin, LOW);
  }
  else
  {
    digitalWrite(R1Pin, HIGH);
//    Endtime2 = 0;   
  }

 



}





